#include "FontView.h"
void FontView::AttachedToWindow()
{
	MakeFocus();
		// init
	//To view a new font, drop it on the window
	DragMessage(new BMessage(FONT_DROPPED),Bounds());
	if(fontpath.InitCheck()==B_OK)
	{
		BString title;
		title << "FontPreviewer - " << fontpath.Leaf();
		Window()->SetTitle(title.String());
		//Invalidate();
		BRect r = Bounds();
		FrameResized(r.Width(),r.Height());
		SetFontPath(fontpath.Path());				
	}	

}
//This scrollbar is a hack, if anyone can fix it so it scroll's nicely and can update
//with respect to the size of the view, please send the code to me! (misza@ihug.com.au)
void FontView::ScrollBy(float h,float v)
{
	BView::ScrollBy(h,v);
	//Invalidate();
}
void FontView::ScrollTo(BPoint where)
{
	BView::ScrollTo(where);
	//Invalidate();
}

FontView::FontView(BRect r) : BView(r,"fontview",B_FOLLOW_ALL,B_WILL_DRAW|B_NAVIGABLE|B_FRAME_EVENTS)
{
	SetViewColor(ui_color(B_PANEL_BACKGROUND_COLOR));
	//A height of 4096 should be plenty (we can't resize BBitmaps
	//on the fly when used like this
	DrawingBitmap= new BBitmap(BRect(0,0,r.Width(),4096),B_RGB32,true);
	DrawingBitmap->Lock();
	bView = new BView(DrawingBitmap->Bounds(),"view",B_FOLLOW_NONE, B_WILL_DRAW);
	DrawingBitmap->AddChild(bView);
	bView->SetViewColor(ui_color(B_PANEL_BACKGROUND_COLOR));
	DrawingBitmap->Unlock();
	fontpath.SetTo("/boot/beos/etc/fonts/ttfonts/Swiss721_Bold.ttf");
	if(fontpath.InitCheck()==B_OK)
	{
		error = FT_Init_FreeType (&lib);
		if (error)
			puts ("Error: FT_Init_FreeType");
		//else
		
		
	}

//	SetViewColor(255,255,255);//ui_color(B_PANEL_BACKGROUND_COLOR));
//	IsOkToDraw = false;
	
}
void FontView::RenderBitmap()
{
	DrawingBitmap->Lock();
	
	if(!IsOkToDraw)
	{
		BRect r = bView->Bounds();
		bView->MovePenTo(0,100);
		bView->SetHighColor(ViewColor());
		bView->FillRect(bView->Bounds());
		BFont font(be_bold_font);
		font.SetSize(64);
		bView->SetFont(&font);
		bView->SetHighColor(0,0,0);
		bView->DrawString("INVALID FONT!");
		bView->MovePenTo(0,100);
		bView->MovePenBy(0,80);
		bView->DrawString("Have a nice day!");

		bView->Sync();
/*		DrawBitmapAsync(DrawingBitmap,bView->Bounds(),bView->Bounds());
		Flush();
		Sync();*/
	DrawingBitmap->Unlock();
		return;
	}
	bView->SetHighColor(ui_color(B_PANEL_BACKGROUND_COLOR));
		//bView->SetHighColor(0,255,0);
		bView->FillRect(bView->Bounds());
	
	int TileSize=63;
	BRect destRect(0,0,TileSize,TileSize);

	int row_number=12;
	int row_incr=0;
	bView->MovePenTo(0,0);
	
	int vecsize = BITMAPS.size();
	for(int i=1;i<=vecsize-1;i++)
	{
		bView->SetDrawingMode(B_OP_ALPHA);
		bView->SetHighColor(0,0,255);
		BRect br = BITMAPS[i]->Bounds();
		float px=bView->PenLocation().x;
		float py=bView->PenLocation().y;
		
		bView->StrokeRect(destRect);	//draw the outline for the box
		
		BPoint pen = BPoint(destRect.left,destRect.top);
		bView->MovePenTo(pen);
		//Scale down the char to fit in the tile, and try to keep aspect ratios.
		//Some chars can be *REALLY* big :P
		if(br.Width() >= destRect.Width() && br.Height() < destRect.Height())
		{
			//here width is the problem.
			float sw = TileSize*3/4;
			float sh = sw/br.Width()*br.Height();
			float left=destRect.left+(destRect.Width()-sw)/2;
			float top=destRect.top+(destRect.Height()-sh)/2;
			bView->DrawBitmap(BITMAPS[i],BITMAPS[i]->Bounds(),BRect(left,top,left+sw,top+sh));
		}
		else if(br.Width() < destRect.Width() && br.Height() >= destRect.Height())
		{
			//here height is the problem.
			float sh = TileSize*3/4;
			float sw = sh/br.Height()*br.Width();
	
			float left=destRect.left+(destRect.Width()-sw)/2;
			float top=destRect.top+(destRect.Height()-sh)/2;
			bView->DrawBitmap(BITMAPS[i],BITMAPS[i]->Bounds(),BRect(left,top,left+sw,top+sh));
			
		}
	
		else if(br.Width() >= destRect.Width() && br.Height() >= destRect.Height())
		{
			//we want to scale to ~ 3/4 the TileSize
			float sh = TileSize*3/4;
			float sw = sh/br.Height()*br.Width();
	
			float left=destRect.left+(destRect.Width()-sw)/2;
			float top=destRect.top+(destRect.Height()-sh)/2;
			bView->DrawBitmap(BITMAPS[i],BITMAPS[i]->Bounds(),BRect(left,top,left+sw,top+sh));
			
	
		}else
		{
			//MovePenTo(BPoint(destRect.left,destRect.top));
			float w=BITMAPS[i]->Bounds().Width();
			float h=BITMAPS[i]->Bounds().Height();
			bView->DrawBitmap(BITMAPS[i],BPoint(destRect.left+(destRect.Width()-w)/2,destRect.top+(destRect.Height()-h)/2));
			
		}

		//draw the char index
		pen = bView->PenLocation();
		BString num;
		num << (int)i;
		BFont font(be_bold_font);
		font.SetSize(16);
		bView->SetFont(&font);
	
		bView->SetHighColor(0,0,255);
		bView->MovePenTo(BPoint(destRect.left+3,destRect.bottom-1));
		bView->DrawString(num.String());
		
		bView->SetHighColor(255,0,0);
		bView->MovePenTo(BPoint(destRect.left+2,destRect.bottom-2));
		bView->DrawString(num.String());
		
		bView->MovePenTo(pen);
	
		//handle when to start a new row
		if(row_incr < row_number)
		{
			destRect.OffsetBy(TileSize,0);
			//MovePenBy(width+1,0);
			row_incr++;
		}else if(row_incr == row_number)
		{
			
			destRect = BRect(0,destRect.top,TileSize,destRect.bottom);
			destRect.OffsetBy(0,TileSize);
			//MovePenTo(0,offset);
			row_incr=0;
		}
	}
	
		//bView->SetHighColor(ViewColor());
		//bView->FillRect(Bounds());

//		bView->SetHighColor(255,0,0);
//		bView->FillRect(bView->Bounds());	
		bView->Sync();
/*		DrawBitmapAsync(DrawingBitmap,bView->Bounds(),bView->Bounds());
		Flush();
		Sync();
		*/
	DrawingBitmap->Unlock();
}
void FontView::FrameResized(float width,float height)
{
	if(IsOkToDraw)
	{
		BScrollBar* bar = ScrollBar(B_VERTICAL);
		if(bar)
		{
			int nglyphs = face->num_glyphs;
			int32 rowheight=(int32)floor(64*nglyphs/13);
			
			BRect r = Frame();
			float h = r.Height();
			if(rowheight < h)
			bar->SetRange(0,0);
			else
			{	bar->SetRange(0,rowheight-h);
				bar->SetProportion(h/rowheight);
			}
			bar->SetSteps(64,64);
		}
	}
}
void FontView::SetFontPath(const char* path)
{
	fontpath.SetTo(path);
	//cout << fontpath.Path() << endl;
	
	if(fontpath.InitCheck()==B_OK)
	{
		error = FT_New_Face (lib,fontpath.Path(), 0, &face);
			if (error) {
				puts ("Error: FT_New_Face -Invalid Font");
				IsOkToDraw = false;
				Window()->SetTitle("FontPreviewer");
		if(Parent())
		{	RenderBitmap();
			Invalidate();
		}
				return;
			}
		Render();
		//RenderBitmap();
		IsOkToDraw = true;
		BString title;
		title << "FontPreviewer - " << fontpath.Leaf();
		Window()->SetTitle(title.String());
		if(Parent())
		{	RenderBitmap();
			Invalidate();
		}
		BRect r = Bounds();
		FrameResized(r.Width(),r.Height());			
	}
	
	
}
void FontView::Render()
{
	int vecsize = BITMAPS.size();
	if(vecsize > 0)
	{
		for(int i=0;i<vecsize;i++)
			delete BITMAPS[i];
		BITMAPS.clear();
	}	
	int nglyphs=face->num_glyphs;
		
	int row_number=12;
	int row_incr=0;
	MovePenTo(0,0);
	// set size
	int32 size = 64;
	error = FT_Set_Char_Size (face, 0, size*64, 0, 0);
	if (error) {
		puts ("Error: FT_Set_Char_Size");
	}
	

	for(int i=1;i<=nglyphs-1;i++)
	{
		//This glyph loading is by scanty :-) Well done mate!
		FT_Load_Glyph (face, i, FT_LOAD_DEFAULT);
		FT_Get_Glyph (face->glyph, &glyph);
	
		if (glyph->format != FT_GLYPH_FORMAT_BITMAP) {
			error = FT_Glyph_To_Bitmap(&glyph, FT_RENDER_MODE_NORMAL, 0, 1);
		}
		
		bitmap = reinterpret_cast<FT_BitmapGlyph>(glyph);
		
		
		uint8 *source = (uint8 *)bitmap->bitmap.buffer;
		
		rgb_color color = {0,0,0,255};
	
		BITMAPS.push_back(new BBitmap (BRect (0, 0, (bitmap->bitmap.width - 1),
			(bitmap->bitmap.rows - 1)), B_RGBA32));
		
		unsigned char* srcLine =  (unsigned char *)bitmap->bitmap.buffer;
		unsigned char* dest2 = (unsigned char *)BITMAPS.back()->Bits();
		
		int rows=bitmap->bitmap.rows;
		int width=bitmap->bitmap.width;
		int bpr=BITMAPS.back()->BytesPerRow();
		int pitch=bitmap->bitmap.pitch;
		
		//I have now idea how this works, but this little beauty corrects
		//the bitmap so that it renders nice with transparency, etc.
		//Written by Michael Pfeiffer (of BePDF fame).
		for (int y = 0; y < rows; y++) 
		{
		rgb_color*     dst = (rgb_color*)dest2;
		unsigned char* TheSource =  srcLine;
		for (int x = 0; x < width; x++, TheSource++, dst++)
		 {
			color.alpha = *TheSource;
			*dst = color;
		}
		srcLine += pitch;
		dest2 += bpr;
		}
	
	FT_Done_Glyph (glyph);//bye bye
	}
}
void FontView::Draw(BRect drawRect)
{
		//DrawingBitmap->Lock();
		DrawBitmapAsync(DrawingBitmap,DrawingBitmap->Bounds(),DrawingBitmap->Bounds());
		Flush();
		Sync();
		//DrawingBitmap->Unlock();
		//RenderBitmap();
//	DrawBitmap(DrawingBitmap);
}
void FontView::MessageReceived(BMessage* msg)
{
	switch(msg->what)
	{
		case B_MOUSE_WHEEL_CHANGED:
		{	//We have a mouse wheel event when the focus is on the desktop.
					float delta_y;
					if(msg->FindFloat("be:wheel_delta_y",&delta_y) == B_OK)
					{
						BScrollBar* bar = ScrollBar(B_VERTICAL);
						if(bar)
						{
							float small,big;
							bar->GetSteps(&small,&big);
							
							if(modifiers() & B_OPTION_KEY)
							{
								//small *= 4;
								big *= 4;
							}
							float val = bar->Value();
							
							if(delta_y > 0)       //move wheel down/back
							{
								bar->SetValue(val+big);	
							}
							else if(delta_y < 0)	//move wheel up/forward
							{
								bar->SetValue(val-big);	
							}
						}
					}
						
		}break;
		default:
			BView::MessageReceived(msg);	
		}
}
void FontView::KeyDown(const char* bytes,int32 numBytes)
{
	BScrollBar* bar = ScrollBar(B_VERTICAL);
	if(bar)					
{		float small,big;
		bar->GetSteps(&small,&big);
		float val = bar->Value();	
	switch(bytes[0])
	{
		case B_HOME:
		{
			bar->SetValue(0);	
			
		}break;
		case B_END:
		{
			float min,max;
			bar->GetRange(&min,&max);
			bar->SetValue(max);
		}break;
		case B_PAGE_UP:
		{
			
			bar->SetValue(val-(big*4));	
		}break;	
		case B_PAGE_DOWN:
		{
			bar->SetValue(val+(big*4));	
		}break;	
		
		case B_UP_ARROW:
			bar->SetValue(val-(big));	
			break;
		case B_DOWN_ARROW:
			bar->SetValue(val+(big));	
			break;
				break;
		//default:
			//BListView:KeyDown(bytes,numBytes);
			//break;	
	}
	}
}