#ifndef _FONTVIEW_H_
#define _FONTVIEW_H_
#include <Font.h>
#include <View.h>
#include <String.h>
#include <Bitmap.h>
#include <ft2build.h>
#include FT_FREETYPE_H
#include FT_INTERNAL_TYPE1_TYPES_H
#include <freetype2/freetype/ftglyph.h>
#include <Entry.h>
#include <Path.h>
#include <OS.h>
#include <ScrollView.h>
#include <vector>
#include <Window.h>
#include <math.h>
const uint32 FONT_DROPPED = 'ftdp';
class FontView : public BView
{
	public:
		FontView(BRect r);
		virtual void Draw(BRect drawRect);
		void SetFontPath(const char* path); 
		void ScrollBy(float h,float v);
		void ScrollTo(BPoint where);
		virtual void AttachedToWindow();
		virtual void FrameResized(float width,float height);
		void Render();
		void RenderBitmap();
		virtual void MessageReceived(BMessage* msg);
		virtual void KeyDown(const char* bytes,int32 numBytes);
	private:
		BPath fontpath;
		status_t error;
		FT_Library lib;
		FT_Face face;
		FT_Vector origin;
		FT_Glyph glyph;
		FT_BitmapGlyph bitmap;
		bool IsOkToDraw;
		vector<BBitmap*> BITMAPS;
		BBitmap* DrawingBitmap;
		BView* bView;
};

#endif